<< problem 13 - Large sum |
![]() |
Lattice paths - problem 15 >> |
Problem 14: Longest Collatz sequence
(see projecteuler.net/problem=14)
The following iterative sequence is defined for the set of positive integers:
if n is even: n \to n/2
if n is odd: n \to 3n + 1
Using the rule above and starting with 13, we generate the following sequence:
13 \to 40 \to 20 \to 10 \to 5 \to 16 \to 8 \to 4 \to 2 \to 1
It can be seen that this sequence (starting at 13 and finishing at 1) contains 10 terms.
Although it has not been proved yet (Collatz Problem), it is thought that all starting numbers finish at 1.
Which starting number, under one million, produces the longest chain?
NOTE: Once the chain starts the terms are allowed to go above one million.
My Algorithm
The longest Collatz chain below five million contains 597 elements (and starts with 3732423).
A brute-force algorithm solves this problem within a half a second.
A smarter approach is to cache all chain lengths we encounter along the way.
My function steps(x)
tries to look up the result for x
in a cache
:
- if it succeeds, just return that cached value
- if it fails, we do one step in the Collatz sequence and call
step
recursively
Alternative Approaches
There are surprisingly few "thresholds", where the Collatz chain length is longer than anything we have seen before:
1, 2, 3, 6, 7, 9, 18, 25, 27, 54,
73, 97, 129, 171, 231, 313, 327, 649, 703, 871,
1161, 2223, 2463, 2919, 3711, 6171, 10971, 13255, 17647, 23529,
26623, 34239, 35655, 52527, 77031, 106239, 142587, 156159, 216367, 230631,
410011, 511935, 626331, 837799,1117065,1501353,1723519,2298025,3064033,3542887,
3732423
This sequence is all we need to solve the original problem (well, this list contains all numbers up to 5000000 but we only need up to 1000000).
You can easily see that 837799 is the largest number less than one million.
Modifications by HackerRank
I compute the Collatz sequences "on-demand":
if the input value x
exceeds maxTested
then all still unknown Collatz sequences up to x
will be analyzed.
Whenever a sequence is at least as long as the longest sequence we observed so far, then I have to update longest
.
This data structure longest
is supposed to hold the values shown above.
However, the modified Hackerrank problem asks for the largest number with a given Collatz chain length
but those numbers refers to the smallest.
Therefore I have to insert all numbers where
length >= longest.rbegin()->second
instead of
length > longest.rbegin()->second
In the end, my std::map
contains a few more values:
1, 2, 3, 6, 7, 9, 18, 19, 25, 27,
54, 55, 73, 97, 129, 171, 231, 235, 313, 327,
649, 654, 655, 667, 703, 871, 1161, 2223, 2322, 2323,
2463, 2919, 3711, 6171, 10971, 13255, 17647, 17673, 23529, 26623,
34239, 35497, 35655, 52527, 77031, 106239, 142587, 156159, 216367, 230631,
410011, 511935, 626331, 837799,1117065,1126015,1501353,1564063,1723519,2298025,
3064033,3542887,3732423
Note
I observed a max. recursion depth of 363 (incl. memoization). This shouldn't be a problem for most computers.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho "1 5000000" | ./14
Output:
Note: the original problem's input 1000000
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <iostream>
#include <vector>
#include <map>
// memoize all paths length for n up to 5000000
const size_t MaxN = 5000000 + 2;
// we could change MaxN at will:
// it just affects performance, not the result
// identify chain lengths we haven't computed so far
const int Unknown = -1;
// store chain lengths
std::vector<short> cache(MaxN, Unknown);
// recursively count steps of Collatz sequence
unsigned short steps(unsigned long long x)
{
// finished recursion ?
if (x == 1)
return 1;
// try to use cached result
if (x < cache.size() && cache[x] != Unknown)
return cache[x];
// next step
long long next;
if (x % 2 == 0)
next = x / 2;
else
next = 3 * x + 1;
// deeper recursion
auto result = 1 + steps(next);
if (x < cache.size())
cache[x] = result;
return result;
}
int main()
{
// [smallest number] => [chain length]
std::map<unsigned int, unsigned int> longest;
// highest number analyzed so far
unsigned int maxTested = 1;
longest[maxTested] = 1; // obvious case
unsigned int tests;
std::cin >> tests;
while (tests--)
{
unsigned int x;
std::cin >> x;
// compute remaining chain lengths
for (; maxTested <= x; maxTested++)
{
// get chain length
auto length = steps(maxTested);
// at least as long as anything we have seen before ?
if (length >= longest.rbegin()->second)
longest[maxTested] = length;
}
// find next longest chain for numbers bigger than x
auto best = longest.upper_bound(x);
// and go one step back
best--;
std::cout << best->first << std::endl;
}
return 0;
}
This solution contains 12 empty lines, 17 comments and 3 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 0.03 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
Peak memory usage was about 12 MByte.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
February 23, 2017 submitted solution
March 31, 2017 added comments
Hackerrank
see https://www.hackerrank.com/contests/projecteuler/challenges/euler014
My code solves 13 out of 13 test cases (score: 100%)
Difficulty
Project Euler ranks this problem at 5% (out of 100%).
Hackerrank describes this problem as easy.
Note:
Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.
In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.
Links
projecteuler.net/thread=14 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
C# www.mathblog.dk/project-euler-14/ (written by Kristian Edlund)
C github.com/eagletmt/project-euler-c/blob/master/10-19/problem14.c (written by eagletmt)
Java github.com/nayuki/Project-Euler-solutions/blob/master/java/p014.java (written by Nayuki)
Javascript github.com/dsernst/ProjectEuler/blob/master/14 Longest Collatz sequence.js (written by David Ernst)
Go github.com/frrad/project-euler/blob/master/golang/Problem014.go (written by Frederick Robinson)
Mathematica github.com/nayuki/Project-Euler-solutions/blob/master/mathematica/p014.mathematica (written by Nayuki)
Haskell github.com/nayuki/Project-Euler-solutions/blob/master/haskell/p014.hs (written by Nayuki)
Scala github.com/samskivert/euler-scala/blob/master/Euler014.scala (written by Michael Bayne)
Perl github.com/gustafe/projecteuler/blob/master/014-Longest-Collatz-sequence.pl (written by Gustaf Erikson)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 | 718 | 719 | 720 | 721 | 722 | 723 | 724 | 725 |
726 | 727 | 728 | 729 | 730 | 731 | 732 | 733 | 734 | 735 | 736 | 737 | 738 | 739 | 740 | 741 | 742 | 743 | 744 | 745 | 746 | 747 | 748 | 749 | 750 |
751 | 752 | 753 | 754 | 755 | 756 | 757 | 758 | 759 | 760 | 761 | 762 | 763 | 764 | 765 | 766 | 767 | 768 | 769 | 770 | 771 | 772 | 773 | 774 | 775 |
776 | 777 | 778 | 779 | 780 | 781 | 782 | 783 | 784 | 785 | 786 | 787 | 788 | 789 | 790 | 791 | 792 | 793 | 794 | 795 | 796 | 797 | 798 | 799 | 800 |
801 | 802 | 803 | 804 | 805 | 806 | 807 | 808 | 809 | 810 | 811 | 812 | 813 | 814 | 815 | 816 | 817 | 818 | 819 | 820 | 821 | 822 | 823 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 13 - Large sum |
![]() |
Lattice paths - problem 15 >> |